Subject: Re: [Autoconf] Closing summary on consensus-call for RFC5889 modifications

From: reshmi r <[email-masked]>
Date: Tue, 24 Aug 2010 10:14:39 +0530

Hi Teco,

Do they really mean a model for the autoconfiguration and is there is
no role for host in autoconfiguration??........the topic goes in to
real debate. what was the final outcome of the discussion???.

Hi All,

Can anyone finalise the suggested outcomes of the discussion??Do you
all really mean that the routers only need to do the autoconfiguration
and the nodes have no role in it??? If so how can we believe a router
to be genuine and how can we ensure that the router will never become
selfish??? so there should be some role in hosts to monitor the
traffic behaviour of router and the host should be able to notify with
some protocol mechanism. do you all really mean to change the title???
I strongly disagree with this.

Rgds,
Reshmi.

Hi Thomas,

On the title change, I remember in Maastricht all accept one
preferred the title change. On the list as well.
There are two arguments.
1) it is _a_ model
2) the model doesn't support hosts, or at least not very well
On the latter, there was a discussion without outcome.

Regards, Teco

---

From: "Dearlove, Christopher (UK)" <[email-masked]>
Date: Tue, 24 Aug 2010 09:55:53 +0100

I think there's a misunderstanding here. All the way back to RFC 2501,
a node has been defined as a router plus possible hosts. If you've got
a wireless device that wants to participate in a MANET it needs to be
running an ad hoc routing protocol, i.e. it's a router. It may perform
only a limited subset of routing functions - consider for example an
OLSR node that does not wish to be a relay, only an endpoint. It can
do that by setting WILLINGNESS equal to zero, and if it is built only
to take such a role it can then throw away large chunks of OLSR code
(for example it never sends TC messages). But the node still has some
router functions. This is the model of both RFC 2501 and 5889-to-be.
The host can then get its addresses in any non-MANET-specific way on
that node.

-- 
Christopher Dearlove
Technology Leader, Communications Group
Communications and Networks Capability
BAE Systems Advanced Technology Centre
West Hanningfield Road, Great Baddow, Chelmsford, CM2 8HN, UK
Tel: +44 1245 242194  Fax: +44 1245 242124

BAE Systems (Operations) Limited
Registered Office: Warwick House, PO Box 87,
Farnborough Aerospace Centre, Farnborough, Hants, GU14 6YU, UK
Registered in England & Wales No: 1996687

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On
Behalf Of reshmi r
Sent: 24 August 2010 05:45
To: [email-masked]
Subject: Re: [Autoconf] Closing summary on consensus-call for
RFC5889modifications

                    *** WARNING ***

  This message has originated outside your organisation,
  either from an external partner or the Global Internet. 
      Keep this in mind if you answer this message.

Hi Teco,

Hi All,

Rgds,
Reshmi.

Hi Thomas,

Regards, Teco
_______________________________________________
Autoconf mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/autoconf

********************************************************************
This email and any attachments are confidential to the intended
recipient and may also be privileged. If you are not the intended
recipient please delete it from your system and notify the sender.
You should not copy it or use it for any purpose nor disclose or
distribute its contents to any other person.
********************************************************************

---

From: reshmi r <[email-masked]>
Date: Tue, 24 Aug 2010 15:37:57 +0530

Hi Christopher,

Thank you for your immediate reply.

Hi All,

But i still have some questions to get it clarified.

I understood all the nodes has the capacity to act as router and some
may be ready to do it.

1. The nodes themself has the capacity to make it act as router(by
setting WILLINGNESS to non zero). But in most of the cases all nodes
are selfish and they does not want to parcipate in routing. So almost
every node will be busy in their host functions alone. so who will
take care of autoconfiguration? Imagine a network with no router!!!!!!
2. There will be more security threats if the node it self has the
capacity to configure  its  WILLINGNESS . The malicious node can
easily get in and set the WILLINGNESS to non zero and participate in
routing functions.
3. If suppose we have a method to select the hosts which can act as
router and set WILLINGNESS manually. What will be the criteria for
router selection??? Is it based on resources, traffic etc etc..

Once again thank you for your reply.

Regards,
Reshmi.T.R.
Reseach Scholar,
Ramanujan Computing center,
Anna University- Chennai
India

  Tue, Aug 24, 2010 at 2:25 PM, Dearlove, Christopher (UK)
<[email-masked]> wrote

---

From: "Dearlove, Christopher (UK)" <[email-masked]>
Date: Tue, 24 Aug 2010 11:50:48 +0100

First note that OLSR is just an example. As a further example,
I haven't checked if AODV and/or DYMO have documented equivalent
features, but they very easily could implement them (don't
forward RREQs).

Of course if every router (or just too many routers) is selfish
the ad hoc network will fail. That's inherent in the whole concept
of an ad hoc network. OLSRv2 points this out when allowing the
concept. But this is not an autoconf or RFC 5889-to-be problem.

I don't see that a node being able to set its own willingness
to zero in any way adds to the threat. A hostile node is more
dangerous with high willingness than with low. But that's not
an authconf/RFC 5889-to-be issue, it's a routing security
problem.

Again, your last point is about routing and management. That's
not to say it and the others aren't good questions when planning
an ad hoc network (not quite an oxymoron) or for research. But
they aren't the issue here.

-----Original Message-----
From: reshmi r [mailto:[email-masked]] 
Sent: 24 August 2010 11:08
To: Dearlove, Christopher (UK)
Cc: [email-masked]
Subject: Re: [Autoconf] Closing summary on consensus-call for RFC5889modifications

                    *** WARNING ***

Hi Christopher,

Hi All,

Regards,
Reshmi.T.R.
Reseach Scholar,

---

From: Teco Boot <[email-masked]>
Date: Tue, 24 Aug 2010 13:09:29 +0200

Reshmi,

The outcome was we didn't agree on what makes a node a router
or a host. And time is too costly to find out.
Some say we only have routers attached to links with undetermined 
characteristics. Others say hosts run OADV.
 
In IPv6, there are some rules for hosts, e.g. RFC 5942:
|   In IPv6, an address is on-link (with respect to a specific link), if
|   the address has been assigned to an interface attached to that
|   link.
Now we have an addressing model that says:
|   No on-link subnet prefix is configured on this interface.

We have to find out how hosts can use the addressing model. And how
routers deal with such hosts. At least it is not clear to me right now.

Regards, Teco

---

From: Juliusz Chroboczek <[email-masked]>
Date: Tue, 24 Aug 2010 19:11:01 +0200

> consider for example an OLSR node that does not wish to be a relay,
> only an endpoint. It can do that by setting WILLINGNESS equal to zero,
> and if it is built only to take such a role it can then throw away
> large chunks of OLSR code (for example it never sends TC messages).

What you're describing is not a router.  It's a host that's snooping on
a routing protocol.

                                        Juliusz

---

From: "Charles E. Perkins" <[email-masked]>
Date: Tue, 24 Aug 2010 12:34:19 -0700

Hello Chris,

A node can easily participate in an ad hoc network
without running OLSR or DYMO or any routing protocol.
Why make the restriction?  I don't understand the value
proposition of disenfranchising so many users and
invalidating so many use cases.

On 8/24/2010 1:55 AM, Dearlove, Christopher (UK) wrote:

> running an ad hoc routing protocol, i.e. it's a router.

Well, opinions vary here, to say the least.

>                                                  It may perform
> OLSR node that does not wish to be a relay, only an endpoint.

I can agree, because the null set is a subset of any set.
Do you call a node that implements a null subset of the routing
functions to be a router?

>                       It can
> router functions.

For instance, could you name one?

>            This is the model of both RFC 2501 and 5889-to-be.

You didn't say why the node has to be a router, except by
pure dint of the logic that it has to be a router.

I don't find that terribly convincing -- and, I do find
it pretty harmful to the prospects of ad hoc networks.

RFC 2501 says:

>                                               ....       a set
>    of nodes--which may be combined routers and hosts--themselves form
>    the network routing infrastructure in an ad hoc fashion.

Let's take it as given that the routers in a MANET are the
nodes that establish the network connectivity (when possible).

Where does it say that a node that DOES NOT do this is then
disqualified for residence in an ad hoc network?

Regards,
Charlie P.

---

From: Teco Boot <[email-masked]>
Date: Tue, 24 Aug 2010 21:34:29 +0200

You enter the twilight zone here.
I say nodes that run routing protocols, and send routing protocol
packets, are routers. Others say these are hosts, if the nodes don't
forward packets.
Snooping the routing protocol is a corner case, I am OK if host could 
do this. The problem here is, when a host has no on-link prefix, how 
can other nodes know the host is reachable? 

Teco

---

From: "Dearlove, Christopher (UK)" <[email-masked]>
Date: Wed, 25 Aug 2010 09:41:50 +0100

It's running the routing protocol, and not just listening
to it, but engaging actively in it - sending necessary
routing protocol messages. It's a router.

-----Original Message-----
From: Juliusz Chroboczek [mailto:[email-masked]] 
Sent: 24 August 2010 18:11
To: Dearlove, Christopher (UK)
Cc: reshmi r; [email-masked]
Subject: Re: [Autoconf] Closing summary on consensus-call for
RFC5889modifications

                    *** WARNING ***

                                        Juliusz

---

From: "Dearlove, Christopher (UK)" <[email-masked]>
Date: Wed, 25 Aug 2010 09:45:07 +0100

I didn't make the definition, go back to RFC 2501. 

If the node is to be mobile, attaching at different points,
available as a destination to others, it has to be running
something.

-----Original Message-----
From: Charles E. Perkins [mailto:[email-masked]] 
Sent: 24 August 2010 20:34
To: Dearlove, Christopher (UK)
Cc: [email-masked]
Subject: Re: [Autoconf] Closing summary on consensus-call for
RFC5889modifications

                    *** WARNING ***

Hello Chris,

Regards,
Charlie P.

---

From: Alexandru Petrescu <[email-masked]>
Date: Wed, 25 Aug 2010 12:05:09 +0200

> routing protocol messages. It's a router.

And a router doesn't necessarily have to run a dynamic routing protocol. 
  A router with static routes (no routing protocol messages) is a router 
too.

Alex

---

From: Teco Boot <[email-masked]>
Date: Wed, 25 Aug 2010 15:21:28 +0200

Alex,

Your statement is not accurate.
You say: "A router with [whatever] is a router to.
Would someone doubt on that?

If you intended to say:
>  A node with static routes (no routing protocol messages) is a router too.

This is definitely not true. Every host may have static routes.

I call a node a router if it:
 - may forward packets;
 - may send routing protocol packets;
 - may send router advertisements.

Reworded: a host 
 - may not forward packets;
 - may not send routing protocol packets;
 - may not send router advertisements.

I have device here on my desk. It is called a Wireless-N Home Router.
I use it as WiFi AP, Ethernet switch and DHCP server.
I don't use it for forwarding packets, because on the yellow marked
port it does some nasty NAPT operations, which I can't use in my setup.
Shall I bring it back to the shop, and ask for a Wireless-N Home Host?
It:
 - may forward packets, but I disabled it;
 - may send routing protocol packets, but I disabled it;
 - may send router advertisements, but I doubt if it supports IPv6.
By the way, if I use packet forwarding, NAPT and MAC NAT, it acts as a host 
on the Internet port. Providers can't detect it is a router, it is all hidden.
Powerful feature, for where providers don't allow routers connected to their 
networks.

Teco

Op 25 aug 2010, om 12:05 heeft Alexandru Petrescu het volgende geschreven:

> And a router doesn't necessarily have to run a dynamic routing protocol.  A router with static routes (no routing protocol messages) is a router too.
> 
> Alex
> 
>> 
> 
>

---

From: "Charles E. Perkins" <[email-masked]>
Date: Wed, 25 Aug 2010 08:02:36 -0700

Hello Chris,

Follow-up below...

 > I didn't make the definition, go back to RFC 2501.

I did.  I even quoted 2501 in part of my message
to you that you didn't answer.

 > available as a destination to others, it has to be running

Mobile nodes do this today and they aren't classified
as routers.  You can even do it without running Mobile IP
to some extent.

Regards,
Charlie P.

---

From: "Dearlove, Christopher (UK)" <[email-masked]>
Date: Wed, 25 Aug 2010 16:17:55 +0100

I didn't have time to pick up all your points (and I don't
really have time even for this, so it will be brief).

You asked what router functions the example I gave satisfied:

- It's running a routing protocol, and actively participating in
  it. For example running OLSR it picks MPRs and communicates
  them.

- When a host on that node sends a packet, it chooses which
  neighbour is to be the next hop (possibly even which interface
  to use to do that) in order to route correctly.

That'll do to be going on from.

As for what my mobile is running to pick different points of
attachment, it's running an entire UMTS protocol stack (and
a GSM one) to select between base stations. And it's a much
more asymmetric relationship than any in an ad hoc network.

-----Original Message-----
From: Charles E. Perkins [mailto:[email-masked]] 
Sent: 25 August 2010 16:03
To: Dearlove, Christopher (UK)
Cc: [email-masked]
Subject: Re: [Autoconf] Closing summary on consensus-call for
RFC5889modifications

                    *** WARNING ***

Hello Chris,

Follow-up below...

Regards,
Charlie P.

---

From: Alexandru Petrescu <[email-masked]>
Date: Wed, 25 Aug 2010 18:03:18 +0200

Le 25/08/2010 15:21, Teco Boot a écrit :
> Alex,
>
> Your statement is not accurate. You say: "A router with [whatever]
> is a router to. Would someone doubt on that?

Right, a router is a router - always valid.

A "machine" with static routes is a router too.

> This is definitely not true. Every host may have static routes.

Right.  That's why I tend to accept that there are no Hosts in this
world and they're all routers, because they all execute longest prefix
match searches in their routing tables, they all have at least two
interfaces (lo is one), they all have entries in their routing tables.

They're all routers, Hosts don't exist.

> I call a node a router if it: - may forward packets; - may send
> routing protocol packets; - may send router advertisements.
>
> Reworded: a host - may not forward packets; - may not send routing
> protocol packets; - may not send router advertisements.

Ah "may" makes it impossible to really distinguish.

> I use it as WiFi AP, Ethernet switch and DHCP server. I don't use it
> for forwarding packets, because on the yellow marked port it does
> some nasty NAPT operations, which I can't use in my setup. Shall I
> bring it back to the shop, and ask for a Wireless-N Home Host?

HA haha!!  I doubt shop vendor understands "Host" because s/he never
sells Hosts to anyone!  S/he could sell Routers, Switches, Desktops,
Servers ; or it could Host your website if you wish.  But never sell you
a Host.  Who sells Hosts?

> It: - may forward packets, but I disabled it; - may send routing
> protocol packets, but I disabled it; - may send router
> advertisements, but I doubt if it supports IPv6.

But that Access Point does have routing table entries, does execute the
longest prefix match algorithm, hence it's a Router.

> By the way, if I use packet forwarding, NAPT and MAC NAT, it acts as
> a host on the Internet port.

In a sense.  What do you mean it "acts as a Host on the Internet port"?
  What does NAPT does as algorithm, data structures, which a Router does
not, on the Internet port?

> Providers can't detect it is a router, it is all hidden. Powerful
> feature, for where providers don't allow routers connected to their
> networks.

Hmm...

I think also, as you say, that it is good to distinguish it based on
sending RA or NA: if it sends RA then it's a Router, otherwise it's a
Host; but disabling RAs on a Router doesn't make it a Host :-) - it
makes it an IPv4 Router (another Router :-)

Alex

>>> It's running the routing protocol, and not just listening to it,
>>> but engaging actively in it - sending necessary routing protocol
>>> messages. It's a router.
>>
>> And a router doesn't necessarily have to run a dynamic routing
>> protocol.  A router with static routes (no routing protocol
>> messages) is a router too.
>>
>> Alex
>>
>>>
>>
>>
>> _______________________________________________ Autoconf mailing
>> list [email-masked]

---

From: Alexandru Petrescu <[email-masked]>
Date: Wed, 25 Aug 2010 18:15:03 +0200

Le 25/08/2010 17:02, Charles E. Perkins a écrit :
> I did. I even quoted 2501 in part of my message to you that you
> didn't answer.
>
> Mobile nodes do this today and they aren't classified as routers.

Charlie - a Node is a Host "or" a Router - this makes all Mobile Nodes
routers...

I have a hard time seeing Hosts anywhere actually.

I agree that a smartphone with a huge IP stack can do many dynamic
addressing and routing things without running dynamic routing protocols,
w/o running Mobile IP.  And that smartphone is a "Host" in the sense
that it is the end of the application (end-to-end), TCP), end of IPsec,
has GUI to human fingers and eyes, browses the Web as a Client for
entertainment -- all being run sometimes by Routers too... they're all
Routers in the end.

Maybe we could distinguish them better based on the data structures and
algos.

Maybe a Host is a machine whose main goal is to run TCP, whereas a
Router's main goal is to run longest-prefix match.

During one identifiable second a machine doing more MIPS for TCP than
for longest-prefix match, is a Host, otherwise it's a Router.

A machine with more bytes in the routing table than in the TCP
structures, at a given time, is a Host.

Or so...

Alex

  You can even do it without running Mobile IP
> Regards, Charlie P.
> _______________________________________________ Autoconf mailing list
> [email-masked] https://www.ietf.org/mailman/listinfo/autoconf
>

---

From: reshmi r <[email-masked]>
Date: Thu, 26 Aug 2010 09:48:22 +0530

Christopher,

So it mean almost all the nodes replying to the routing messages will
be mentioned as router.
For eg: As we were discussing before, only some routing protocols like
OLSR support Multicast so only in that case you will have much
difference for a router and a node. In other cases all the nodes helps
in message unicasts and broadcasts so they all have to be mentioned as
router.

I may define a router as the node which runs a routing protocol in it,
then updates the routing information and send the routing informations
to other nodes. So here In those protocols which doesnot support
multicast every node acts as router.

Reshmi.T.R
Research Scholar,
Ramanujan Computing Center,
Anna University- Chennai,
Chennai, India

---

From: Teco Boot <[email-masked]>
Date: Thu, 26 Aug 2010 14:31:19 +0200

Alex,

You could take some time for research, on hosts having a routing table.
Take a start with host requirements (RFC 1122):
|  As an extra feature, a host IP layer MAY implement a table
|  of "static routes".

Teco

---

From: Alexandru Petrescu <[email-masked]>
Date: Thu, 26 Aug 2010 15:57:15 +0200

Le 26/08/2010 14:31, Teco Boot a écrit :
> Alex,
>
> You could take some time for research, on hosts having a routing
> table. Take a start with host requirements (RFC 1122): |  As an
> extra feature, a host IP layer MAY implement a table |  of "static
> routes".

Ah well spot.  In practice that is actually a MUST - every IP stack has
a table of routes, be it ran by Hosts or by Routers.  There's no IP
stack without routing table.

This is one reason why I think it's difficult to identify a Host which
is not a Router, nor a Router which is not a Host.

Probably one could call a Host a Host if it does more TCP instructions
during 1 second, than routing instructions.

Alex

>>> Your statement is not accurate. You say: "A router with
>>> [whatever] is a router to. Would someone doubt on that?
>>
>> world and they're all routers, because they all execute longest
>> prefix match searches in their routing tables, they all have at
>> least two interfaces (lo is one), they all have entries in their
>> routing tables.
>>
>>> Reworded: a host - may not forward packets; - may not send
>>> routing protocol packets; - may not send router advertisements.
>>
>>> I have device here on my desk. It is called a Wireless-N Home
>>> Router. I use it as WiFi AP, Ethernet switch and DHCP server. I
>>> don't use it for forwarding packets, because on the yellow
>>> marked port it does some nasty NAPT operations, which I can't use
>>> in my setup. Shall I bring it back to the shop, and ask for a
>>> Wireless-N Home Host?
>>
>> HA haha!!  I doubt shop vendor understands "Host" because s/he
>> never sells Hosts to anyone!  S/he could sell Routers, Switches,
>> Desktops, Servers ; or it could Host your website if you wish.
>> But never sell you a Host.  Who sells Hosts?
>>
>> But that Access Point does have routing table entries, does
>> execute the longest prefix match algorithm, hence it's a Router.
>>
>>> By the way, if I use packet forwarding, NAPT and MAC NAT, it
>>> acts as a host on the Internet port.
>>
>> In a sense.  What do you mean it "acts as a Host on the Internet
>> port"? What does NAPT does as algorithm, data structures, which a
>> Router does not, on the Internet port?
>>
>>> feature, for where providers don't allow routers connected to
>>> their networks.
>>
>> Hmm...
>>
>> I think also, as you say, that it is good to distinguish it based
>> on sending RA or NA: if it sends RA then it's a Router, otherwise
>> it's a Host; but disabling RAs on a Router doesn't make it a Host
>> :-) - it makes it an IPv4 Router (another Router :-)
>>
>> Alex
>>
>>>
>>> Teco
>>>
>>>
>>>
>>>>> It's running the routing protocol, and not just listening to
>>>>> it, but engaging actively in it - sending necessary routing
>>>>> protocol messages. It's a router.
>>>>
>>>> _______________________________________________ Autoconf
>>>> mailing list [email-masked]

---

From: "Charles E. Perkins" <[email-masked]>
Date: Thu, 26 Aug 2010 07:00:00 -0700

Hello Christopher,

I didn't ask what functions YOUR routers performed.

I asked what functions a node would be REQUIRED to
perform in order to communicate in an ad hoc network.

A host does NOT have to pick MPRs in order to
forward packets to a default router.  A host does
NOT have to run a routing protocol in order to
identify one or more default routers.  A host
does NOT have to run a routing protocol in order
to select among network interfaces for delivering
packets to one of its possibly several default
routers.

Surely it must be possible to have a discussion
about this without meandering afar from the point.

Regards,
Charlie P.

---

From: "Charles E. Perkins" <[email-masked]>
Date: Thu, 26 Aug 2010 07:06:31 -0700

Hello Teco,

I'd like to propose how we can distinguish routers
from hosts, as follows:

- If a node forwards packets as an intermediate node
   in a routing path, it is a "router".
- Otherwise, it is "host".

As one example, suppose network entity X runs
a routing protocol and exchanges routing tables.
Furthermore, suppose X drops every packet that
it receives unless the destination address is
X's IP address.

I do not call X a router.

Suppose instead that X forwards every other
packet.

I call X a defective router.

You might instead prefer to call X a router
if it exchanges routing tables with its
neighbors.  That is also workable, I think,
but less convenient and vulnerable to arguments
related to the use of SNMP.

Anyway, for all those who cannot tell the
difference between routers and hosts by
any definition whatsoever, I can't see how
it matters what terminology the proposed
RFC might use.

Regards,
Charlie P.

---

From: "Dearlove, Christopher (UK)" <[email-masked]>
Date: Thu, 26 Aug 2010 15:21:27 +0100

This started from the specific example, so that is clearly quite
to the point. You may now be discussing other cases, but that's
another matter.

If by a node we mean a physically separate entity (in a
wireless network) and if we allow that node to be independently
mobile and to connect to other nodes (otherwise it's not really
an ad hoc node) and it is to be unicast reachable from elsewhere
in the network via one of those other nodes, then it has to be
running something. It's for you to indicate what that something
is and why that isn't a routing protocol, despite having some
(agreed, not all) routing functions, and how it will work in a
MANET with wireless links (with the usual non-transitive
properties).

Otherwise you are asking me to prove a negative, and we know
how easy that is.

-----Original Message-----
From: Charles E. Perkins [mailto:[email-masked]] 
Sent: 26 August 2010 15:00
To: Dearlove, Christopher (UK)
Cc: [email-masked]
Subject: Re: [Autoconf] Closing summary on consensus-call for
RFC5889modifications

                    *** WARNING ***

Hello Christopher,

Regards,
Charlie P.

---

From: Teco Boot <[email-masked]>
Date: Thu, 26 Aug 2010 20:07:04 +0200

Alex,

In my environment, host don't use TCP very often. My apps use UDP.
Internet core routers often use BGP, which run on TCP.
Let's stick on more commonly used differentiators.
Like forwarding packets, sending RA or sending routing protocol packets.

Teco

---

From: Teco Boot <[email-masked]>
Date: Thu, 26 Aug 2010 20:17:26 +0200

Charlie,

Learning default gateways in a passive mode is well accepted behavior
of hosts. It is mentioned in RFC 1122:
|  This technique depends upon the host passively
|  receiving ("wiretapping") the Interior Gateway Protocol
|  (IGP) datagrams that the gateways are broadcasting to
| each other. 

But signaling from hosts to routers is another story. We have NDP or 
ARP for this. One could think of redistributing NDP / ARP learned routing
info into the routing protocol. I am not sure we should go there.

Teco

---

From: Alexandru Petrescu <[email-masked]>
Date: Thu, 26 Aug 2010 22:08:32 +0200

Let's try to loop this Router-Host definition towards the original post
intention, not immediately, but let's at least try.

Le 26/08/2010 20:07, Teco Boot a écrit :
> Internet core routers often use BGP, which run on TCP. Let's stick
> on more commonly used differentiators. Like forwarding packets,
> sending RA or sending routing protocol packets.

If the distinguisher for Routers is "forward packets whose dst is not
self, _instead of dropping_ " the distinguisher for Hosts could be "drop
packets whose dst is not self, instead of forwarding".

In this sense, sending or receiving routing protocol packets is actually
a Host characteristic, because dst is self at reception.

Remind the original topic problem?  How do the different suggestions
Host-Router we make could affect the use of "Router" vs the use of
"Host" in the title?

I could live with the RFC title saying this is about Routers, because
people on this list seem to understand a Router to be a Host too and
vice-versa.

Nobody seems to be ready to actually list the things a computer does
making it a Router (and not a Host).  If so, why the struggle?

If you want to list the things, let me start:

An IPv6 Router (remark, not simply "a Router") does these things which
an IPv6 Host does not:
-MUST send RA (a Host MUST NOT).
-MUST forward packets whose dst address is not assigned to any of its
  interfaces (a Host MUST drop packets whose dst is not assigned to any
  of its interfaces, and must further process and still not forward
  packets whose dst is assigned to at least one address assigned to one
  of its interfaces, _or_ part of a multicast group to which this host
  has previously subscribed).
-MUST send ICMP Redirect (a Host MUST NOT) if the need is present.
-MAY join a multicast group, in the perspective of using that group
  subscription later as a Host.
-MUST decrement the Hop Limit (a Host MUST NOT).
-MUST NOT process the IPsec headers (a Host MUST).
-there are surely others - but are you willing to continue.

Remark the sending of routing protocol messages is not part of this
list, because it's actually a Host characteristic.

And, if you find exception to any of these rules - feel free to do so,
then please come up with some means to define them better, and continue
on it.

There is much lack of discussion synthesis here.

Alex

>>>  extra feature, a host IP layer MAY implement a table |  of
>>> "static routes".
>>
>> Ah well spot.  In practice that is actually a MUST - every IP
>> stack has a table of routes, be it ran by Hosts or by Routers.
>> There's no IP stack without routing table.
>>
>> This is one reason why I think it's difficult to identify a Host
>> which is not a Router, nor a Router which is not a Host.
>>
>> Probably one could call a Host a Host if it does more TCP
>> instructions during 1 second, than routing instructions.
>>
>> Alex
>>
>>>
>>> Teco
>>>
>>>> Right.  That's why I tend to accept that there are no Hosts in
>>>> this world and they're all routers, because they all execute
>>>> longest prefix match searches in their routing tables, they
>>>> all have at least two interfaces (lo is one), they all have
>>>> entries in their routing tables.
>>>>
>>>>> I call a node a router if it: - may forward packets; - may
>>>>> send routing protocol packets; - may send router
>>>>> advertisements.
>>>>>
>>>>> Router. I use it as WiFi AP, Ethernet switch and DHCP server.
>>>>> I don't use it for forwarding packets, because on the yellow
>>>>> marked port it does some nasty NAPT operations, which I can't
>>>>> use in my setup. Shall I bring it back to the shop, and ask
>>>>> for a Wireless-N Home Host?
>>>>
>>>>  never sells Hosts to anyone!  S/he could sell Routers,
>>>> Switches, Desktops, Servers ; or it could Host your website if
>>>> you wish. But never sell you a Host.  Who sells Hosts?
>>>>
>>>>> It: - may forward packets, but I disabled it; - may send
>>>>> routing protocol packets, but I disabled it; - may send
>>>>> router advertisements, but I doubt if it supports IPv6.
>>>>
>>>> In a sense.  What do you mean it "acts as a Host on the
>>>> Internet port"? What does NAPT does as algorithm, data
>>>> structures, which a Router does not, on the Internet port?
>>>>
>>>>> Providers can't detect it is a router, it is all hidden.
>>>>> Powerful feature, for where providers don't allow routers
>>>>> connected to their networks.
>>>>
>>>> Hmm...
>>>>
>>>> I think also, as you say, that it is good to distinguish it
>>>> based on sending RA or NA: if it sends RA then it's a Router,
>>>> otherwise it's a Host; but disabling RAs on a Router doesn't
>>>> make it a Host :-) - it makes it an IPv4 Router (another
>>>> Router :-)
>>>>
>>>> Alex
>>>>
>>>>>
>>>>> Teco
>>>>>
>>>>>
>>>>>
>>>>>>> It's running the routing protocol, and not just
>>>>>>> listening to it, but engaging actively in it - sending
>>>>>>> necessary routing protocol messages. It's a router.
>>>>>>
>>>>>> And a router doesn't necessarily have to run a dynamic
>>>>>> routing protocol.  A router with static routes (no routing
>>>>>> protocol messages) is a router too.
>>>>>>
>>>>>> Alex
>>>>>>
>>>>>>>
>>>>>>
>>>>>>

---

From: "Charles E. Perkins" <[email-masked]>
Date: Thu, 26 Aug 2010 20:26:56 -0700

Hello Chris,

I'm responding again, because I'd like to have a fruitful
discussion.

> to the point. You may now be discussing other cases, but that's

Do you mean the specific example of your nodes running
OLSR and identifying MPRs?  I'm happy to agree that your
nodes are routers.

If I discussed other cases, it was only to reach the
goal of identifying the boundary between hostness and
routerness.  Is that sufficiently to the point?

> running something.

Obviously...  it's running some computer programs.

If a node runs ARP, is it a router?

>             It's for you to indicate what that something

I already mentioned several examples.  Should I do it
again?  What about a node running ND?  What about a node
snooping the airwaves?  What about a node running Mobile IP?
I've just scratched the surface of examples.  In fact
I'll even play dirty and keep you in suspense to wait for
a new Internet Draft I am co-authoring on this subject.

> Otherwise you are asking me to prove a negative, and we know

I'm asking you to accept that a node can beneficially
reside in an ad hoc network without being a router.
What is negative about that?

Unless I completely misunderstand your point of view,
this is not in any way asking you to prove a negative.
Of course it is possible to prove a negative proposition.
But, I have not asked you to do so.  Or, what negative
proposition do you believe I have postulated for your
consideration?  If I put "not" in any point of discussion,
have I exceeded my boundaries of feasible communication?

Regards,
Charlie P.

---

From: "Dearlove, Christopher (UK)" <[email-masked]>
Date: Fri, 27 Aug 2010 09:26:58 +0100

I'm failing to see how any of the examples you quote (which I
agree, would not make a node a router) are sufficient for all 
of the functionality I noted. I really would like (but I'll
be unable to reply to for at least some days - it's a long
weekend coming up) to know how you get the functionality.
Ideally I'd like equivalent functionality to the OLSR example,
what I wouldn't count is where a host node is permanently
(albeit wirelessly) attached to a single other router node.
How far from the latter and close to the former can you get?
(I can see how to get from the one permanent point of
attachment to occasionally changing that, with transients,
using Mobile IP.)

-----Original Message-----
From: Charles E. Perkins [mailto:[email-masked]] 
Sent: 27 August 2010 04:27
To: Dearlove, Christopher (UK)
Cc: [email-masked]
Subject: Re: [Autoconf] Closing summary on consensus-call for
RFC5889modifications

                    *** WARNING ***

Hello Chris,

Regards,
Charlie P.

---

From: Teco Boot <[email-masked]>
Date: Fri, 27 Aug 2010 11:53:23 +0200

Hi Charlie,

More thoughts on the grey zone, separating host and routers.
You stick to the basic definition: routers forward packets, hosts do not. 
OK?

We had discussion on routing protocol speakers. I said: sending routing 
protocol packets makes a node a router.

But for routing protocol speakers, that:
 - do not forward packets
 - do not send RAs
 - do not advertise any willingness to forward packets
Would that be routers?

If you say: no, these are hosts, I can follow.
But for accepting such, it should be made clear to other nodes, that 
the routing protocol speaker is a host, not a router.
Some mechanisms:
 - passive mode / don't send routing protocol packets at all
 - OLSR willingness = WILL_NEVER (0)
 - not advertise any links
 - advertise links, but with "do not use" attribute / metric
 - only put reachability for itself in AODV / DYMO messages
 - never send BGP reachability with own address as next_hop

Using this classification, a BGP route server is a nice example for a 
host being an active routing protocol speaker.
draft-jasinska-ix-bgp-route-server-00:
|  Although a route server uses BGP to exchange
|  reachability information with each of its clients, it does not
|  forward traffic itself and is therefore not a router.

If we agree on such classification, there is some advertorial work to do.
Because many would say (ad hoc) routing protocol speakers are routers. 
E.g. we need errata on RFC's from MANET WG and update the active drafts.
Also, draft-ietf-autoconf-adhoc-addr-model-03 needs a revision. Change 
/router/node/, but not global change (not in section 6.1, last bullet).
RFC5998 is waiting for approval by Mark. 
Mark?

And using Router-ID's on hosts?
Hmmm.

Regards, Teco

---

From: "Charles E. Perkins" <[email-masked]>
Date: Fri, 27 Aug 2010 04:28:58 -0700

Hello Chris,

The examples I gave DO NOT provide the
functionality in your message.

That _is_ the point.  The point is that a node can
beneficially reside in an ad hoc network without
doing those things.  ... and that we should not
legislate otherwise.

Regards,
Charlie P.

---

From: "Dearlove, Christopher (UK)" <[email-masked]>
Date: Fri, 27 Aug 2010 13:27:28 +0100

There's a key question as to how much functionality.

If a node just has a single point of attachment to an unchanging
router, then router prefix autoconf is sufficient, as the host
node can just get an address from its router. If we extend that
so that it can now move, and use Mobile IP with its home location
being the router it first attached to, ditto.

The question is what is the case where the host node is doing
something useful, but can't just get an address delegated to
it by an autoconfed router?

(I am not saying I don't think there is such a case. I'm just
saying I haven't seen it - quite a different thing.)

-----Original Message-----
From: Charles E. Perkins [mailto:[email-masked]] 
Sent: 27 August 2010 12:29
To: Dearlove, Christopher (UK)
Cc: [email-masked]
Subject: Re: [Autoconf] Closing summary on consensus-call for
RFC5889modifications

                    *** WARNING ***

Hello Chris,

Regards,
Charlie P.

---

From: "Charles E. Perkins" <[email-masked]>
Date: Fri, 27 Aug 2010 11:41:48 -0700

Hello Chris,

> There's a key question as to how much functionality.

This is an important point.  The functionality needed by
a host in order to connect to network depends on the
functionality provided by the router that offers the
netwok prefix.

> being the router it first attached to, ditto.

Check.

> saying I haven't seen it - quite a different thing.)

Well, there are such cases, and they should be allowed.

Regards,
Charlie P.

---

From: "Charles E. Perkins" <[email-masked]>
Date: Fri, 27 Aug 2010 20:34:40 -0700

Hello Teco,

> If you say: no, these are hosts, I can follow.

These are hosts.  Check.

> the routing protocol speaker is a host, not a router.

Now you lost me.  Why must such a host need to be mentioned
to other nodes?  If it were mentioned (e.g., by a proactive
routing protocol) why would it have to be identified as a
non-routing host?

>   - never send BGP reachability with own address as next_hop

What mechanisms are these?  Host mechanisms?
How is "not advertising" a "mechanism" (for example)?

> host being an active routing protocol speaker.

The host is a router server, not a router.

> Because many would say (ad hoc) routing protocol speakers are routers.

Yes, people are saying this.  I don't agree.
It sounds to me like a way to wind up toy angels and
get them to dance on the head of a pin, so to speak.

> E.g. we need errata on RFC's from MANET WG and update the active drafts.

I'd have to check on this.

Regards,
Charlie P.

---

From: Teco Boot <[email-masked]>
Date: Tue, 31 Aug 2010 08:43:54 +0200

Hi Charlie,

> routing protocol) why would it have to be identified as a
If other nodes are not aware of this_node, they don't send packets to it.
If other nodes are not aware this_node does not forward packets, it could
be a black hole. This_node MUST NOT be the next hop for other destinations.

> What mechanisms are these?  Host mechanisms?
These are mechanisms for making sure other nodes are aware this_node
does not forward packets to other destinations.
I am not sure how this may work for NHDP (in OLSR, appendix B.7.).

> How is "not advertising" a "mechanism" (for example)?
Example: in OSPF terms: not sending LSA.

> The host is a router server, not a router.
A host is not a router. I don't get your message. 

> Yes, people are saying this.  I don't agree.
My point is, if you do not agree, you could be more responsive to WGLCs on this.
Take for example the RFC5889-draft and the new charter. These are full of term 
"router", which if you were consistent, you would strongly disagree on.

> I'd have to check on this.
You better do.

Charlie,
I can support the idea MANET routing protools may run on hosts.
But for this discussion, can we be somewhat to the point?
It may help. And be less time consuming.

Regards, Teco

---

From: "Dearlove, Christopher (UK)" <[email-masked]>
Date: Tue, 31 Aug 2010 09:40:04 +0100

Can you outline such a case. It's not the simple use of Mobile IP
noted below as for that router prefix autoconfiguration is sufficient.

-----Original Message-----
From: Charles E. Perkins [mailto:[email-masked]] 
Sent: 27 August 2010 19:42
To: Dearlove, Christopher (UK)
Cc: [email-masked]
Subject: Re: [Autoconf] Closing summary on consensus-call for
RFC5889modifications

                    *** WARNING ***

Hello Chris,

Check.

Regards,
Charlie P.